
package com.phongnguyen93.bluekai;

import android.util.Log;
import com.bluekai.sdk.BlueKai;
import com.bluekai.sdk.listeners.DataPostedListener;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.ReadableMap;
import com.facebook.react.bridge.ReadableMapKeySetIterator;
import java.util.HashMap;
import java.util.Map;

public class RNBlueKaiModule extends ReactContextBaseJavaModule implements DataPostedListener {

  public static final String REACT_NAME = "RNBlueKai";
  private final ReactApplicationContext reactContext;
  private BlueKai blueKai;

  public RNBlueKaiModule(ReactApplicationContext reactContext, String siteId) {
    super(reactContext);
    this.reactContext = reactContext;
    blueKai = BlueKai.getInstance( this.reactContext.getCurrentActivity(),this.reactContext,BuildConfig.DEBUG,false,siteId,"1.0.0",this,null,false);
    if(blueKai!=null){
      blueKai.setOptInPreference(true);
    }

  }

  @Override
  public String getName() {
    return REACT_NAME;
  }

  @ReactMethod
  public void putValue(String key, String value){
    if(blueKai != null){
      blueKai.put(key,value);
    }
  }

  @ReactMethod
  public void putValues(ReadableMap keyValueMap){
    if(blueKai != null && keyValueMap.keySetIterator()!=null){
      Map<String,String> stringMap = new HashMap<>();
      ReadableMapKeySetIterator keySetIterator = keyValueMap.keySetIterator();
      while (keySetIterator.hasNextKey()){
        String key = keySetIterator.nextKey();
        if(key != null) stringMap.put(key,keyValueMap.getString(key));
      }
      if(!stringMap.isEmpty()){
        blueKai.putAll(stringMap);
      }
    }
  }

  @Override public void onDataPosted(boolean b, String s) {
    Log.d(REACT_NAME,s+": is sent = "+b);
  }
}